Hardware Locality (hwloc): Interoperability with the AMD SMI Management Library

Hardware Locality (hwloc) 2.14.0rc1

Functions
Interoperability with the AMD SMI Management Library

## Functions
int | hwloc_amdsmi_get_device_cpuset (hwloc_topology_t topology, amdsmi_processor_handle proc, hwloc_cpuset_t set)
hwloc_obj_t | hwloc_amdsmi_get_device_osdev_by_index (hwloc_topology_t topology, uint32_t hip_id)
hwloc_obj_t | hwloc_amdsmi_get_device_osdev (hwloc_topology_t topology, amdsmi_processor_handle proc)

## Detailed Description

This interface offers ways to retrieve topology information about devices managed by the AMD SMI Management Library.

## Function Documentation

## ◆ hwloc_amdsmi_get_device_cpuset()

int hwloc_amdsmi_get_device_cpuset | ( | hwloc_topology_t | topology,
|  | amdsmi_processor_handle | proc,
|  | hwloc_cpuset_t | set )
| inline

Get the CPU set of logical processors that are physically close to AMD GPU device whose index is `dv_ind`.

Store in `set` the CPU-set describing the locality of the AMD GPU device whose processor handle is `proc`.

Topology `topology` and device `dv_ind` must match the local machine. I/O devices detection and the ROCm SMI component are not needed in the topology.

The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see hwloc_amdsmi_get_device_osdev() and hwloc_amdsmi_get_device_osdev_by_index().

This function is currently only implemented in a meaningful way for Linux; other systems will simply get the cpuset of the entire topology.

Returns
  0 on success.
  -1 on error, for instance if device information could not be found.

## ◆ hwloc_amdsmi_get_device_osdev()

hwloc_obj_t hwloc_amdsmi_get_device_osdev | ( | hwloc_topology_t | topology,
|  | amdsmi_processor_handle | proc )
| inline

Get the hwloc OS device object corresponding to AMD GPU device, whose processor handle is `proc`.

Returns
  The hwloc OS device object that describes the given AMD GPU, whose processor handle is `proc`.
  `NULL` if none could be found.

Topology `topology` and processor handle `proc` must match the local machine. I/O devices detection and the RSMI component must be enabled in the topology. If not, the locality of the object may still be found using hwloc_amdsmi_get_device_cpuset().

Note
  The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out).

## ◆ hwloc_amdsmi_get_device_osdev_by_index()

hwloc_obj_t hwloc_amdsmi_get_device_osdev_by_index | ( | hwloc_topology_t | topology,
|  | uint32_t | hip_id )
| inline

Get the hwloc OS device object corresponding to the AMD GPU device whose HIP index is `hip_id`.

Returns
  The hwloc OS device object describing the AMD GPU device whose HIP index is `hip_id`.
  `NULL` if none could be found.

The topology `topology` does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the RSMI component must be enabled in the topology.

Note
  The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out).